#### options:
# Use the following --with/--without <option> switches to control how the
# package will be built:
# 
# modular_x:   modular X dependencies
%bcond_without modular_x
# lcms:        lcms support
%bcond_without lcms
# python:      python support
%bcond_without python
# mp:          multi processor support
%bcond_without mp
# static:      build static libraries
%bcond_with static
# print:       build the print plugin (if you don't build it externally)
%bcond_without print
# gutenprint:  require gutenprint-plugin (instead of gimp-print-plugin) if
#              internal print plugin isn't built
%bcond_without gutenprint
# convenience: install convenience symlinks
%bcond_without convenience
# aalib:       build with AAlib (ASCII art gfx library)
%if 0%{?res} != 0
# don't use aalib on RHEL
%bcond_with aalib
%else
%bcond_without aalib
%endif

Summary:        GNU Image Manipulation Program
Name:           gimp
Epoch:          2
Version:        2.6.9
Release:        4%{?dist}.3
%define binver 2.6
%define gimp_lang_ver 20
%define interfacever 2.0
%define age 0
%define minorver 600
%define microver %(ver=%{version}; echo ${ver##*.*.})
License:        GPLv2+
Group:          Applications/Multimedia
URL:            http://www.gimp.org/
BuildRoot:      %{_tmppath}/%{name}-%{version}-root-%(%__id_u -n)
Obsoletes:      gimp-perl < 2:2.0
Obsoletes:      gimp < 2:2.6.0-3
BuildRequires:  chrpath >= 0.13-5
%if %{with aalib}
BuildRequires:  aalib-devel
%endif
BuildRequires:  alsa-lib-devel >= 1.0.0
BuildRequires:  babl-devel >= 0.0.22
BuildRequires:  cairo-devel >= 1.4.10
BuildRequires:  curl-devel >= 7.15.1
BuildRequires:  dbus-glib-devel >= 0.70
BuildRequires:  fontconfig-devel >= 2.2.0
BuildRequires:  freetype-devel >= 2.1.7
BuildRequires:  gegl-devel >= 0.0.18
BuildRequires:  glib2-devel >= 2.16.1
BuildRequires:  gnome-keyring-devel >= 0.4.5
BuildRequires:  gnome-vfs2-devel >= 2.10.0
BuildRequires:  gtk2-devel >= 2.12.5
BuildRequires:  gtk-doc >= 1.0
BuildRequires:  gtkhtml2-devel >= 2.0.0
BuildRequires:  hal-devel >= 0.5.7
BuildRequires:  libexif-devel >= 0.6.15
BuildRequires:  libgnomeui-devel >= 2.10.0
BuildRequires:  libjpeg-devel
BuildRequires:  libmng-devel
BuildRequires:  libpng-devel
BuildRequires:  librsvg2-devel >= 2.14.0
BuildRequires:  libtiff-devel
BuildRequires:  libwmf-devel >= 0.2.8
BuildRequires:  pango-devel >= 1.18.0
%if 0%{?fedora}%{?res} == 0 || 0%{?fedora} > 8 || 0%{?rhel} > 5
BuildRequires:  poppler-glib-devel >= 0.4.1
%else
BuildRequires:  poppler-devel >= 0.4.1
%endif
BuildRequires:  python-devel
BuildRequires:  pygtk2-devel >= 2.10.4
BuildRequires:  pygobject2-devel
%if 0%{?fedora}%{?res} == 0 || 0%{?fedora} > 10 || 0%{?rhel} > 5
BuildRequires:  webkitgtk-devel >= 1.1.0
%else
BuildRequires:  WebKit-gtk-devel >= 1.1.0
%endif
%if %{with modular_x}
BuildRequires:  libX11-devel
BuildRequires:  libXmu-devel
%else
BuildRequires:  xorg-x11-devel
%endif
BuildRequires:  sed
BuildRequires:  intltool
BuildRequires:  gettext
BuildRequires:  findutils
%if %{with lcms}
BuildRequires:  lcms-devel >= 1.16
%endif

Requires:       glib2 >= 2.16.1
Requires:       gtk2 >= 2.12.5
Requires:       pango >= 1.18.0
Requires:       freetype >= 2.1.7
Requires:       fontconfig >= 2.2.0
%if ! %{with print}
%if %{with gutenprint}
Requires:       gutenprint-plugin
%else
Requires:       gimp-print-plugin
%endif
%endif
Requires:       hicolor-icon-theme
Requires:       pygtk2 >= 2.10.4
Requires:       xdg-utils
Requires:       gimp-libs%{?_isa} = %{?epoch:%{epoch}:}%{version}-%{release}

Source0:        ftp://ftp.gimp.org/pub/gimp/v%{binver}/gimp-%{version}.tar.bz2
# distro specific: use xdg-open instead of firefox as web browser
Patch0:         gimp-2.6.2-xdg-open.patch
# https://bugzilla.gnome.org/show_bug.cgi?id=559081
# "JPEG Save dialog preview should adjust size units"
Patch1:         gimp-2.6.7-jpeg-units.patch
# https://bugzilla.gnome.org/show_bug.cgi?id=556896
# "Dialogs don't get minimized with single image window"
Patch2:         gimp-2.6.6-minimize-dialogs.patch
# backport: fix building with "gold" linker
Patch3:         gimp-2.6.8-gold.patch
# backport: GIMP crashes when clicking any scroll bar from combo boxes
Patch4:         gimp-2.6.9-combo-popup.patch
# https://bugzilla.redhat.com/show_bug.cgi?id=198367
# https://bugzilla.gnome.org/show_bug.cgi?id=623045
# make script-fu logging IPv6 aware
Patch5:         gimp-2.6.9-script-fu-ipv6.patch
# CVE-2010-4540, -4541, -4542
# https://bugzilla.redhat.com/show_bug.cgi?id=666793
# https://bugzilla.redhat.com/show_bug.cgi?id=703403
# https://bugzilla.redhat.com/show_bug.cgi?id=703405
Patch6:         gimp-2.6.9-CVE-2010-4540,4541,4542.patch
# CVE-2010-4543, -2011-1782
# https://bugzilla.redhat.com/show_bug.cgi?id=703407
# https://bugzilla.redhat.com/show_bug.cgi?id=704512
Patch7:         gimp-2.6.9-CVE-2010-4543,2011-1782.patch
# CVE-2011-2896
# https://bugzilla.redhat.com/show_bug.cgi?id=727800
Patch8:         gimp-2.6.9-CVE-2011-2896.patch
# CVE-2012-3403
# https://bugzilla.redhat.com/show_bug.cgi?id=839020
Patch9:         gimp-2.6.9-CVE-2012-3403.patch
# CVE-2012-3481
# https://bugzilla.redhat.com/show_bug.cgi?id=847303
Patch10:        gimp-2.6.9-CVE-2012-3481.patch
# files changed by autoreconf after applying the above
Patch100:       gimp-2.6.9-3-autoreconf.patch.bz2

%description
GIMP (GNU Image Manipulation Program) is a powerful image composition and
editing program, which can be extremely useful for creating logos and other
graphics for webpages. GIMP has many of the tools and filters you would expect
to find in similar commercial offerings, and some interesting extras as well.
GIMP provides a large image manipulation toolbox, including channel operations
and layers, effects, sub-pixel imaging and anti-aliasing, and conversions, all
with multi-level undo.

%package libs
Summary:        GIMP libraries
Group:          System Environment/Libraries
License:        LGPLv2+

%description libs
The gimp-libs package contains shared libraries needed for the GNU Image
Manipulation Program (GIMP).

%package devel
Summary:        GIMP plugin and extension development kit
Group:          Development/Libraries
License:        LGPLv2+
Requires:       gimp-libs%{?_isa} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       gimp-devel-tools = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       gtk2-devel
Requires:       glib2-devel
Requires:       gtk-doc
Requires:       pkgconfig

%description devel
The gimp-devel package contains the static libraries and header files
for writing GNU Image Manipulation Program (GIMP) plug-ins and
extensions.

%package devel-tools
Summary:        GIMP plugin and extension development tools
Group:          Development/Tools
License:        LGPLv2+
Requires:       gimp-devel = %{?epoch:%{epoch}:}%{version}-%{release}

%description devel-tools
The gimp-devel-tools package contains gimptool, a helper program to build GNU
Image Manipulation Program (GIMP) plug-ins and extensions.

%package help-browser
Summary:        GIMP help browser plug-in
Group:          Applications/Multimedia
License:        GPLv2+
Obsoletes:      gimp < 2:2.6.0-3
Requires:       gimp%{?_isa} = %{?epoch:%{epoch}:}%{version}-%{release}

%description help-browser
The gimp-help-browser package contains a lightweight help browser plugin for
viewing GIMP online help.

%prep
cat << EOF

Build options:
modular X:                                %{with modular_x}
LCMS support:                             %{with lcms}
Python support:                           %{with python}
MP support:                               %{with mp}
build static libs:                        %{with static}
build internal print plugin:              %{with print}
include convenience symlinks:             %{with convenience}
build the print plugin:                   %{with print}
%if ! %{with print}
prefer gutenprint over (external) gimp-print plugin:
                                          %{with gutenprint}
%endif
build ASCII art plugin                    %{with aalib}


EOF

%setup -q -n gimp-%{version}
%patch0 -p1 -b .xdg-open
%patch1 -p1 -b .jpeg-units
%patch2 -p1 -b .minimize-dialogs
%patch3 -p1 -b .gold
%patch4 -p1 -b .combo-popup
%patch5 -p1 -b .script-fu-ipv6
%patch6 -p1 -b .CVE-2010-4540,4541,4542
%patch7 -p1 -b .CVE-2010-4543,2011-1782
%patch8 -p1 -b .CVE-2011-2896
%patch9 -p1 -b .CVE-2012-3403
%patch10 -p1 -b .CVE-2012-3481

%patch100 -p1 -b .autoreconf

%build
# Use PIC/PIE because gimp is likely to deal with files coming from untrusted
# sources
CFLAGS='-fPIC %optflags -fno-strict-aliasing'
CXXFLAGS='-fPIC %optflags -fno-strict-aliasing'
LDFLAGS='-pie'
%configure \
    --disable-perl --enable-gimp-remote \
%if %{with python}
    --enable-python \
%else
    --disable-python \
%endif
%if %{with mp}
    --enable-mp \
%else
    --disable-mp \
%endif
%if %{with static}
    --enable-static \
%else
    --disable-static \
%endif
%if %{with print}
    --with-print \
%else
    --without-print \
%endif
%if %{with lcms}
    --with-lcms \
%else
    --without-lcms \
%endif
    --enable-gimp-console \
%if %{with aalib}
    --with-aa \
%else
    --without-aa \
%endif
%ifos linux
    --with-linux-input \
%endif
    --with-libtiff --with-libjpeg --with-libpng --with-libmng --with-libexif \
    --with-gtkhtml2 --with-librsvg --with-poppler --with-gnomevfs --with-alsa \
    --with-webkit --with-dbus --with-script-fu

make %{?_smp_mflags}

%install
rm -rf %{buildroot}

# makeinstall macro won't work here - libexec is overriden
make DESTDIR=%{buildroot} install

# remove rpaths
find %buildroot -type f -print0 | xargs -0 -L 20 chrpath --delete --keepgoing 2>/dev/null || :

%ifos linux
# remove .la files
find %buildroot -name \*.la -exec %__rm -f {} \;
%endif

#
# Plugins and modules change often (grab the executeable ones)
#
echo "%defattr (-, root, root)" > gimp-plugin-files
find %{buildroot}%{_libdir}/gimp/%{interfacever} -type f | sed "s@^%{buildroot}@@g" | grep -v '\.a$' >> gimp-plugin-files

# .pyc and .pyo files don't exist yet
grep "\.py$" gimp-plugin-files > gimp-plugin-files-py
for file in $(cat gimp-plugin-files-py); do
    for newfile in ${file}c ${file}o; do
        fgrep -q -x "$newfile" gimp-plugin-files || echo "$newfile"
    done
done >> gimp-plugin-files

%if %{with static}
echo "%defattr (-, root, root)" > gimp-static-files
find %{buildroot}%{_libdir}/gimp/%{interfacever} -type f | sed "s@^%{buildroot}@@g" | grep '\.a$' >> gimp-static-files
%endif

#
# Auto detect the lang files.
#
%find_lang gimp%{gimp_lang_ver}
%find_lang gimp%{gimp_lang_ver}-std-plug-ins
%find_lang gimp%{gimp_lang_ver}-script-fu
%find_lang gimp%{gimp_lang_ver}-libgimp
%find_lang gimp%{gimp_lang_ver}-tips
%find_lang gimp%{gimp_lang_ver}-python

cat gimp%{gimp_lang_ver}.lang gimp%{gimp_lang_ver}-std-plug-ins.lang gimp%{gimp_lang_ver}-script-fu.lang gimp%{gimp_lang_ver}-libgimp.lang gimp%{gimp_lang_ver}-tips.lang gimp%{gimp_lang_ver}-python.lang > gimp-all.lang

#
# Build the master filelists generated from the above mess.
#
cat gimp-plugin-files gimp-all.lang > gimp.files

%if %{with convenience}
# install convenience symlinks
ln -snf gimp-%{binver} %{buildroot}%{_bindir}/gimp
ln -snf gimp-%{binver}.1 %{buildroot}%{_mandir}/man1/gimp.1
ln -snf gimp-console-%{binver} %{buildroot}/%{_bindir}/gimp-console
ln -snf gimp-console-%{binver}.1 %{buildroot}/%{_mandir}/man1/gimp-console.1
ln -snf gimp-remote-%{binver} %{buildroot}%{_bindir}/gimp-remote
ln -snf gimp-remote-%{binver}.1 %{buildroot}%{_mandir}/man1/gimp-remote.1
ln -snf gimptool-%{interfacever} %{buildroot}%{_bindir}/gimptool
ln -snf gimptool-%{interfacever}.1 %{buildroot}%{_mandir}/man1/gimptool.1
ln -snf gimprc-%{binver}.5 %{buildroot}/%{_mandir}/man5/gimprc.5
%endif

%clean
rm -rf %{buildroot}

%post
/usr/bin/update-desktop-database %{_datadir}/applications &> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%postun
if [ "$1" = "0" ]; then
    /usr/bin/update-desktop-database %{_datadir}/applications &> /dev/null || :
fi
touch --no-create %{_datadir}/icons/hicolor
if [ -x %{_bindir}/gtk-update-icon-cache ]; then
  %{_bindir}/gtk-update-icon-cache --quiet %{_datadir}/icons/hicolor || :
fi

%post libs -p /sbin/ldconfig
%postun libs -p /sbin/ldconfig

%files -f gimp.files
%defattr(-, root, root, 0755)
%doc AUTHORS COPYING ChangeLog NEWS README
%doc docs/*.xcf*
%{_datadir}/applications/*.desktop

%dir %{_datadir}/gimp
%dir %{_datadir}/gimp/%{interfacever}
%{_datadir}/gimp/%{interfacever}/tips/
%{_datadir}/gimp/%{interfacever}/menus/
%dir %{_libdir}/gimp
%dir %{_libdir}/gimp/%{interfacever}
%dir %{_libdir}/gimp/%{interfacever}/environ
#%dir %{_libdir}/gimp/%{interfacever}/fonts
%dir %{_libdir}/gimp/%{interfacever}/interpreters
%dir %{_libdir}/gimp/%{interfacever}/modules
%dir %{_libdir}/gimp/%{interfacever}/plug-ins
%exclude %{_libdir}/gimp/%{interfacever}/plug-ins/help-browser
%dir %{_libdir}/gimp/%{interfacever}/python
#%dir %{_libdir}/gimp/%{interfacever}/tool-plug-ins

%{_datadir}/gimp/%{interfacever}/brushes/
%{_datadir}/gimp/%{interfacever}/fractalexplorer/
%{_datadir}/gimp/%{interfacever}/gfig/
%{_datadir}/gimp/%{interfacever}/gflare/
%{_datadir}/gimp/%{interfacever}/gimpressionist/
%{_datadir}/gimp/%{interfacever}/gradients/
# %{_datadir}/gimp/%{interfacever}/help/
%{_datadir}/gimp/%{interfacever}/images/
%{_datadir}/gimp/%{interfacever}/palettes/
%{_datadir}/gimp/%{interfacever}/patterns/
%{_datadir}/gimp/%{interfacever}/scripts/
%{_datadir}/gimp/%{interfacever}/themes/

%dir %{_sysconfdir}/gimp
%dir %{_sysconfdir}/gimp/%{interfacever}
%config(noreplace) %{_sysconfdir}/gimp/%{interfacever}/controllerrc
%config(noreplace) %{_sysconfdir}/gimp/%{interfacever}/gimprc
%config(noreplace) %{_sysconfdir}/gimp/%{interfacever}/gtkrc
%config(noreplace) %{_sysconfdir}/gimp/%{interfacever}/unitrc
%config(noreplace) %{_sysconfdir}/gimp/%{interfacever}/ps-menurc
%config(noreplace) %{_sysconfdir}/gimp/%{interfacever}/sessionrc
%config(noreplace) %{_sysconfdir}/gimp/%{interfacever}/templaterc
%config(noreplace) %{_sysconfdir}/gimp/%{interfacever}/menurc

%{_bindir}/gimp-%{binver}
%{_bindir}/gimp-remote-%{binver}
%{_bindir}/gimp-console-%{binver}

%if %{with convenience}
%{_bindir}/gimp
%{_bindir}/gimp-remote
%{_bindir}/gimp-console
%endif

%{_mandir}/man1/gimp-%{binver}.1*
%{_mandir}/man1/gimp-remote-%{binver}.1*
%{_mandir}/man1/gimp-console-%{binver}.1*
%{_mandir}/man5/gimprc-%{binver}.5*

%if %{with convenience}
%{_mandir}/man1/gimp.1*
%{_mandir}/man1/gimp-remote.1*
%{_mandir}/man1/gimp-console.1*
%{_mandir}/man5/gimprc.5*
%endif

%{_datadir}/icons/hicolor/*/apps/gimp.png
%{_datadir}/icons/hicolor/scalable/apps/gimp.svg

%files libs
%defattr(-, root, root, 0755)
%{_libdir}/libgimp-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimp-%{interfacever}.so.%{age}
%{_libdir}/libgimpbase-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimpbase-%{interfacever}.so.%{age}
%{_libdir}/libgimpcolor-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimpcolor-%{interfacever}.so.%{age}
%{_libdir}/libgimpconfig-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimpconfig-%{interfacever}.so.%{age}
%{_libdir}/libgimpmath-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimpmath-%{interfacever}.so.%{age}
%{_libdir}/libgimpmodule-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimpmodule-%{interfacever}.so.%{age}
%{_libdir}/libgimpthumb-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimpthumb-%{interfacever}.so.%{age}
%{_libdir}/libgimpui-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimpui-%{interfacever}.so.%{age}
%{_libdir}/libgimpwidgets-%{interfacever}.so.%{age}.%{minorver}.%{microver}
%{_libdir}/libgimpwidgets-%{interfacever}.so.%{age}

%if %{with static}
%files devel -f gimp-static-files
%else
%files devel
%endif
%defattr (-, root, root, 0755)
%doc HACKING README.i18n
%doc %{_datadir}/gtk-doc/html/*/

%{_libdir}/*.so
%dir %{_libdir}/gimp
%dir %{_libdir}/gimp/%{interfacever}
%dir %{_libdir}/gimp/%{interfacever}/modules
%ifnos linux
%{_libdir}/*.la
%{_libdir}/gimp/%{interfacever}/modules/*.la
%endif
%{_datadir}/aclocal/*.m4
%{_includedir}/gimp-%{interfacever}
%{_libdir}/pkgconfig/*

%files devel-tools
%defattr (-, root, root, 0755)
%{_bindir}/gimptool-%{interfacever}
%{_mandir}/man1/gimptool-%{interfacever}.1*

%if %{with convenience}
%{_bindir}/gimptool
%{_mandir}/man1/gimptool.1*
%endif

%files help-browser
%defattr (-, root, root, 0755)
%{_libdir}/gimp/%{interfacever}/plug-ins/help-browser


%changelog

